﻿namespace TabsStudioNavigator
{
    class CommandsImpl
    {
        public CommandsImpl(TabsStudioExt.ITabsStudioEngine engine_)
        {
            engine = engine_;
        }

        public void NavigateToNextTab()
        {
            ShiftToTab(1);
        }

        public void NavigateToPreviousTab()
        {
            ShiftToTab(-1);
        }

        public void NavigateToTab(int i)
        {
            foreach (TabsStudioExt.Tabs tabs in engine.GetTabs())
            {
                if (tabs.IsGroupSelected)
                {
                    ActivateTab(i - 1, tabs);
                    return;
                }
            }
        }

        private void ShiftToTab(int offset)
        {
            foreach (TabsStudioExt.Tabs tabs in engine.GetTabs())
            {
                if (tabs.IsGroupSelected)
                {
                    foreach (TabsStudioExt.Tab tab in tabs.TabList)
                    {
                        if (tab.IsTabSelected)
                        {
                            ActivateTab(tabs.TabPanel2.Children.IndexOf(tab.TabItem) + offset, tabs);
                            return;
                        }
                    }
                }
            }
        }

        private void ActivateTab(int i, TabsStudioExt.Tabs tabs)
        {
            if (i >= tabs.TabPanel2.Children.Count || i < 0)
                return;
            TabsStudioExt.Tab tabToNavigate =
                FindTabByItem(tabs.TabPanel2.Children[i] as System.Windows.Controls.TabItem, tabs);
            FindActiveExtension(tabToNavigate).Window.Activate();
        }

        private TabsStudioExt.Tab FindTabByItem(System.Windows.Controls.TabItem tabItem, TabsStudioExt.Tabs tabs)
        {
            foreach (TabsStudioExt.Tab tab in tabs.TabList)
            {
                if (tab.TabItem == tabItem)
                    return tab;
            }
            return null;
        }

        private TabsStudioExt.TabExtension FindActiveExtension(TabsStudioExt.Tab tab)
        {
            foreach (TabsStudioExt.TabExtension tabExtension in tab.TabExtensions)
            {
                if (tabExtension.IsExtensionActive)
                    return tabExtension;
            }
            return null;
        }

        private TabsStudioExt.ITabsStudioEngine engine;
    }
}
